<?php

namespace Drupal\check_username\Controller;

use Drupal\Core\Controller\ControllerBase;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;

/**
 * Returns responses for check_username routes.
 */
class CheckUsernameController extends ControllerBase {

  /**
   * Checks if the username is unique for user.
   *
   * @param \Symfony\Component\HttpFoundation\Request $request
   *
   * @return \Symfony\Component\HttpFoundation\JsonResponse
   */
  public function checkUsername(Request $request): JsonResponse {
    $uid = $request->get('uid');
    $allowed = TRUE;
    $msg = '';
    $username = $request->get('username');
    $query = \Drupal::entityQuery('user')
      ->condition('name', $username);
    if ($uid) {
      $query = $query->condition('uid', $uid, '<>');
    }
    $ids = $query->execute();
    if ($ids) {
      $allowed = FALSE;
      $msg = $this->t('The name %username is already taken.', ['%username' => $username]);
    }
    return new JsonResponse(['allowed' => $allowed, 'msg' => $msg]);
  }

}
